/*
**	deconv.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>
#include <math.h>
#include "deconv.h"

#define OLOP	1
#define ILOP	300
#define HLP	300	// for ind1.yuv
//#define ILOP	100 #define HLP	300	// for inb1.yuv
//#define ILOP	50 #define HLP	50	// for ina3.yuv
//#define ILOP	20 #define HLP	25
//2766 #define H 6 #define V 10
//3026 #define H 12 #define V 8
//2620 #define H 18 #define V 12
// 17x17 is best? in9.yuv need to be odd value
//#define H 13 #define V 6	// for ina3.yuv
//#define H 24 #define V 24	// for inb1.yuv with ADL
//#define H 16 #define V 16
#define H 5
#define V 5
//ory #define SX 1024 #define SY 560
//op  #define SX 1600 #define SY 1200
//op2 #define SX 1280 #define SY 960
//in# #define SX 512  #define SY 512
//inc #define SX 400  #define SY 400
#define SX 240
#define SY 320
//#define TST
//#define LPC
//#define Wiener
//#define INV_MAT
//#define IIR
#define FP (1.2)
#define IIR1	// hierarchical
//#define IIR2	// image division
//#define IIR3	// hierarchical and image division

#define HIR  3	// 4 for def., 2 for ina3.yuv
#define EXPD 0	// expand est directly, input as init est, else expanded.
#define AVGE 1	// average est
#define T 0.000001
#define GAMMA 1	// special gamma  (1: default, power 2.2)
#define OFFSET 0 // special offset min value of input is 33 (kif_2620)

#define FULLP

#define MAX(a,b) ((a<b)?b:a)
#define MIN(a,b) ((a>b)?b:a)
#ifdef FULLP
#define LX(a,c) (MIN(MAX(a,0),c-1))
#define LY(a,c) (MIN(MAX(a,0),c-1))
#else
#define LX(a,c) (a)
#define LY(a,c) (a)
#endif

// psf sequence: 32,16,8,4,2  or 35,17,9,5,3 
#define H2 ((H+1)/2)
#define V2 ((V+1)/2)
#define H3 ((H2+1)/2)
#define V3 ((V2+1)/2)
#define H4 ((H3+1)/2)
#define V4 ((V3+1)/2)
#define H5 ((H4+1)/2)
#define V5 ((V4+1)/2)
#define PEX(n) ((n[j/2][i/2]+n[j/2][(i+1)/2]+n[(j+1)/2][i/2]+n[(j+1)/2][(i+1)/2])/4)
#define SPEL(a) ((a[j*2][i*2]+a[j*2][i*2+1]+a[j*2+1][i*2]+a[j*2+1][i*2+1])/4)

#define GE	// EX= SX, EY= SY
#ifdef IIR2
#define GE	// global estimate img
#define FULL
//#define PART
//#define DIVD	// Divide
#endif

#ifdef DIVD
#define DX 16
#define DY 16
#else
#define DX (1<<(HIR-1))
#define DY DX
#endif

// process image buffer size
//#define PX (SX/DX + H + DX)
//#define PY (SY/DY + V + DY)

#define PX SX
#define PY SY

//#define VSEP
#define M (H/2)
#define Fs 64 // Fs >= H
#define U (V/2)
#define P (H)
#define N (P*P)
//#define RECALC	// error recalc
//#define BEST		// distingish ests before/after change
#ifdef BEST
#define best es0	// estmate before change
#else
#define best es		// estimate changing or after change
#endif

#ifdef GE
#define es(y,x) est[sy+y][sx+x]
#define es0(y,x) est0[sy+y][sx+x]
#define in(y,x) inp[sy+y][sx+x]
#define EX SX
#define EY SY
#else
#define es(y,x) est[y][x]
#define es0(y,x) est0[y][x]
#define in(y,x) inp[y][x]
#define EX PX
#define EY PY
#endif
//making yuv file for mpeg encode
//int fr;
//#define iwt(a,b,c,d)
//#define wt(a,b) wtf("n",fr++,a)
//-------------------------typedefs---------------------------------------------

typedef unsigned char	Uc;
typedef double		Ft;	// fft data type
typedef double		Mt;	// mat[][] data type
typedef double		dbt;
typedef struct{ Uc y[SY  ][SX  ]; Uc c[2][SY/2][SX/2]; }Sif;
typedef struct{ Ft re; Ft im; } complex;
typedef struct{ int x; int y; } pos;
typedef struct{ pos s; pos e; } rect;

//------------------------static variables-------------------------------------
int accl= 2;	// accellation value
int estm= 3;	// 0:alg0 (error deliver to estimated image by psf)
		// 1:alg1 (err ddeliver to est by psf*est with normalization)
		// 2:lucy // Lucy's algorithm 
		// 3:unified modification of est
int psfm= 3;	// 1:lucy rate(chi)^accl * est(xi) (Lucy's PSF modification)
		// 2:adl  not calc 	(deliver same error to est and psf)
		// 3:smpl error(chi)^accl (>th) * est(xi)
		// 4:smpl sqrt(sqrt())
int expd= EXPD;	// 1: expand direct
int avge= AVGE; // 1: average est
int pri= 0;	// print iteration number
int prm= 1;	// print matrix PSF
int pre= 1;	// print error (rms)
int iloop= ILOP;
int use_gamma= GAMMA;	// 1: normal 2.2
int use_expand= 0;	// output [16,255]to[0,255] (for 601 video luma only)
extern int grid;
int peak_pos_x;
int peak_pos_y;

#ifdef GET_PSF
int gpsf= 1;
#else
int gpsf= 0;
#endif

static	Sif	in,ou,ot;	// images
static	Mt	mat2[V][H];	// input h(l,k)
static	Mt	mat3[V][H];	// modified h(l,k)
static	Mt	mat4[V][H];	// highpass
static	Mt	psfa[DY][DX][V][H];	// PSF array
#ifdef VSEP
static	Mt	mats[4][V][H];	// psf is modified
#endif

dbt inp[EY][EX];// input degraded
dbt est[EY][EX];// estimate
dbt est0[EY][EX];// estimate before modified
dbt flt[PY][PX];// filtered and clipped or error
dbt err[PY][PX];// error
dbt rat[PY][PX];// rate error
dbt tmp[EY][EX];// tmporal

#ifdef HIR
dbt est2[EY/2][EX/2];// estimate
dbt est20[EY/2][EX/2];// estimate
dbt inp2[EY/2][EX/2];// input degraded
dbt err2[PY/2][PX/2];// error
dbt rat2[PY/2][PX/2];// rate error
dbt est3[EY/4][EX/4];// estimate
dbt est30[EY/4][EX/4];// estimate
dbt inp3[EY/4][EX/4];// input degraded
dbt err3[PY/4][PX/4];// error
dbt rat3[PY/4][PX/4];// rate error
dbt est4[EY/8][EX/8];// estimate
dbt est40[EY/8][EX/8];// estimate
dbt inp4[EY/8][EX/8];// input degraded
dbt err4[PY/8][PX/8];// error
dbt rat4[PY/8][PX/8];// rate error
dbt est5[EY/16][EX/16];// estimate
dbt est50[EY/16][EX/16];// estimate
dbt inp5[EY/16][EX/16];// input degraded
dbt err5[PY/16][PX/16];// error
dbt rat5[PY/16][PX/16];// rate error
#endif

char name[256]="init";

// for FFT
static complex	wk[Fs][Fs];	// fft buffer
static complex	wkt[Fs][Fs];	// fft buffer
static double	matrix[N][N*2];
int xoff,yoff;
//----------------------initial PSF's------------------------------------------
int cx=  H/2; int cy= V/2;
int ix= -H/2; int ax= H-1-H/2;
int iy= -V/2; int ay= V-1-V/2;
#ifdef HIR
int ixa[5]={    -H/2,     -H2/2,     -H3/2,     -H4/2,     -H5/2};
int iya[5]={    -V/2,     -V2/2,     -V3/2,     -V4/2,     -V5/2};
int axa[5]={ H-1-H/2, H2-1-H2/2, H3-1-H3/2, H4-1-H4/2, H5-1-H5/2};
int aya[5]={ V-1-V/2, V2-1-V2/2, V3-1-V3/2, V4-1-V4/2, V5-1-V5/2};
#endif
#define O 0
static Uc mat[V*H];
//---- gamma(power of 2.22)  and inverse gamma (power of 0.45)------------------
dbt
gamma_(dbt v){	// ~ pow(x/255,2.222)
	v-= OFFSET;
	v/= 255.;
	if(v<0.) v= 0.; if(v>1.) v= 1.;

	if(use_gamma==1){
		if(v<.081) v/= 4.5;
		else v= pow((v+.099)/1.099,1/.45);
	} else if(use_gamma) {
		v= pow(v,(double)use_gamma);
	}

	if(v<0.) v= 0.; if(v>1.) v= 1.;
	return v;
}
int
igamma(dbt v){	// ~ pow(x,0.45)*255
	int i;
	if(v<0.) v= 0.; if(v>1.) v= 1.;

	if(use_gamma==1){
		if(v<.018) v*= 4.5;
		else v= 1.099*pow(v,.45)-.099;
	} else if(use_gamma) {
		v= pow(v,1./use_gamma);
	}
	v*= 255.;
	v+= OFFSET;
	if(use_expand) v= (v-16)*255/(235-16);//16-235=>0-255(ITU-R601 luma)
	i= v+.5;
	if(i<0)i= 0; if(i>255)i= 255;
	return i;
}
//----------------------- print array ------------------------------------------
void
pr_mat(Mt m[V][H]) {
	int i,j;
	for(j=0;j<V;j++){
		for(i=0;i<H;i++) {
			if(m[j][i]==0) printf(" -");
			else printf("%2d",(int)(m[j][i]*V*H));
		}
		printf("\n");
	}
	printf("\n");
}
#ifdef HIR
void
pr_mat_hir(int h, int v, Mt m[v][h]) {
	int i,j;
	for(j=0;j<v;j++){
	for(i=0;i<h;i++){
		if(m[j][i]==0) printf(" -");
		else printf("%2d",(int)(m[j][i]*v*h));
	}
	printf("\n");
	}
	printf("\n");
}
#endif

//----------------------- small array funcs ------------------------------------
void clr(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= 0; }
void no_minus(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) if(a[j][i]<0) a[j][i]= 0; }
void plus(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= fabs(a[j][i]); }
void sqr(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= sqrt(a[j][i]); }
void mls(Mt a[V][H],Mt b) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]*= b; }
void add(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]+= b[j][i]; }
void add2(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]+= b[j][i]/3; }
void sub(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]-= b[j][i]; }
void mlt(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]*= b[j][i]; }
void dvd(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]/= b[j][i]; }
void cpy(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]=  b[j][i]; }
void subs(Mt a[V][H],int c) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) { a[j][i]-= c; if(a[j][i]<0)a[j][i]= 0;} }
void avg(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= (a[j][i]+b[j][i])/2; }
dbt  sum(Mt a[V][H]) { int i,j; dbt s= 0; for(j=0;j<V;j++) for(i=0;i<H;i++) s+= a[j][i]; return s; }
void clrl(Mt* a,      int l)	{ int i; for(i=0;i<l;i++) a[i]= 0; }
void addl(Mt* a,Mt* b,int l)	{ int i; for(i=0;i<l;i++) a[i]+= b[i]; }
void mlsl(Mt* a,Mt s, int l)	{ int i; for(i=0;i<l;i++) a[i]*= s; }
void cpyl(Mt* a,Mt* b,int l)	{ int i; for(i=0;i<l;i++) a[i]= b[i]; }
void avgl(Mt* a,Mt* b,int l)	{ int i; for(i=0;i<l;i++) a[i]= (a[i]+b[i])/2; }
void
shrink_img(int ex,int ey, dbt b[][ex], dbt a[][ex*2]) {
int i,j; for(j=0;j<ey;j++) for(i=0;i<ex;i++) b[j][i]= SPEL(a);
}
void
expand_img(int ex, int ey, dbt a[][ex], dbt b[][ex/2]) {
int i,j; for(j=0;j<ey;j++) for(i=0;i<ex;i++) a[j][i]= PEX(b);
//int i,j; for(j=0;j<ey;j++) { for(i=0;i<ex-1;i++) a[j][i]= PEX(b); a[j][i]= b[j/2][i/2]; }
}
void
expand_direct(int l, dbt a[][EX], dbt c[][EX>>l]) {
int i,j; for(j=0;j<EY;j++) for(i=0;i<EX;i++) a[j][i]= c[j>>l][i>>l];
}
void
flat_psf(Mt* m, int len) { int i; for(i=0;i<len;i++) m[i]= 1./len; }
void
shrink_psf(int h, int v, int h2, int v2, Mt m[][h], Mt n[][h2]) {
int i,j; for(j=0;j<v;j++) for(i=0;i<h;i++) m[j][i]= SPEL(n); norm_hir(h,v,m);
}
void
expand_psf(int h, int v, int h2, int v2, Mt m[][h], Mt n[][h2]) {
int i,j; for(j=0;j<v;j++) for(i=0;i<h;i++) m[j][i]= PEX(n);
//int i,j; for(j=0;j<v;j++) { for(i=0;i<h-1;i++) m[j][i]= PEX(n); m[j][i]= n[j/2][i/2]; }
	norm_hir(h,v,m);
}
//---------------- between Sif image and dbt image array -----------------------
// Sif (upleft (sx,sy) to (ex-1,ey-1)) ==> dbt array
void
sif2dbl(rect *r, int ex, Uc p[][ex],dbt b[][ex])
{
	int i,j;
	for(j=r->s.y;j<r->e.y;j++)
	for(i=r->s.x;i<r->e.x;i++) b[j-r->s.y][i-r->s.x]= gamma_((dbt)p[j][i]);
}
#ifdef GE
void
sif2g_est(Sif *p, dbt b[SY][SX])	// copy whole sif to double type image
{
	int i,j;
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i++) b[j][i]= gamma_((dbt)p->y[j][i]);
}
// ===> back to Sif(sx,sy)-(ex-1,ey-1)
void
dbl2sif(rect *ir, rect *or, int sx, dbt b[][sx],Uc p[][sx]) // copy back selected area
{
	int i,j,dx,dy;
	dx= or->s.x - ir->s.x;
	dy= or->s.y - ir->s.y;
	for(j=or->s.y;j<or->e.y;j++)
	for(i=or->s.x;i<or->e.x;i++) p[j][i]= igamma(b[j][i]);
}
#else
void
dbl2sif(rect *ir, rect *or, int px, dbt b[][px], Uc p[][px])
{
	int i,j,dx,dy;
	dx= or->s.x - ir->s.x;
	dy= or->s.y - ir->s.y;
	for(j=0;j<or->e.y - or->s.y;j++)
	for(i=0;i<or->e.x - or->s.x;i++) p[j+ or->s.y][i+ or->s.x]= igamma(b[j+dy][i+dx]);
}
#endif

//------ normalize (only from ix to ax, from iy to ay)-----------------
int
norm1(Mt m[V][H], double c) // normalize sum of mat to 1.
{
	int i,j; double sum= 0;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) sum+= m[j+U][i+M];
	sum/= c; //printf("normalize sum:%f to %f\n",sum,c);
	if(sum==0.) return 1;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) m[j+U][i+M]/= sum;
	return 0;
}
int
norm_hir(int h, int v, Mt m[v][h])
{
	int i,j; dbt sum= 0;
	for(j=0;j<v;j++)
	for(i=0;i<h;i++) sum+= m[j][i];
	if(sum==0.) return 1;
	for(j=0;j<v;j++)
	for(i=0;i<h;i++) m[j][i]/= sum;
	if(prm)pr_mat_hir(h,v,m);
	return 0;
}
Mt m1[V][H];
Mt last_err;
Mt lastm[V][H];

//----------------------- mk_unif --------------------------------
void
mk_unif(rect *or, rect *of, Mt psf[V][H]) // filter estimate by psf
{
	int i,j,k,l,c; dbt a,e,s;
	int sx= or->s.x; int dx= or->e.x - sx;	// used as pos
	int sy= or->s.y; int dy= or->e.y - sy;	// by es(),in()
	Mt b[V][H];
lo:
	if(psfm==2) clr(m1);
#ifdef BEST
	memcpy(est0,est,sizeof(est));	// est before modified
#endif
	s= c= 0;
	for(j=of->s.y;j<of->e.y;j++)
	for(i=of->s.x;i<of->e.x;i++) {	// flt, err, rat area
		a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++)
			a+= b[l+U][k+M]= best(j-l,i-k)*psf[l+U][k+M];
		if(a< T) a= T; if(a> 1.) a= 1.;
		flt[j][i]= a;
		err[j][i]= in(j,i)-a;
		rat[j][i]= in(j,i)/a;
		s+= err[j][i] * err[j][i]; c++;
		a= err[j][i]/a;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) { e= a*b[l+U][k+M]; es(j-l,i-k)+= e; m1[l+U][k+M]+= e; }
	}
	s/= c;
	if(last_err!=0 && s>last_err) { avg(psf,lastm); goto lo; }
	else { last_err= s; cpy(lastm,psf); }
	if(pre)printf(" %f\n",sqrt(s));
}

//----------------------- make error ------------------------------------------
void
mk_err(rect *or, rect *of, Mt psf[V][H]) // filter estimate by psf
{
	int i,j,k,l,c=0;
	int sx= or->s.x; int dx= or->e.x - sx;	// used as pos
	int sy= or->s.y; int dy= or->e.y - sy;	// by es(),in()
	Mt s= 0;
lo:
	s= c= 0;
	for(j=of->s.y;j<of->e.y;j++)
	for(i=of->s.x;i<of->e.x;i++) {	// flt, err, rat area
		dbt a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) a+= es(j-l,i-k) * psf[l+U][k+M];
		if(a< T) a= T; if(a> 1.) a= 1.;
		flt[j][i]= a;
		err[j][i]= in(j,i)-a;
		rat[j][i]= in(j,i)/a;
		s+= err[j][i] * err[j][i];
		c++;
	}
	s/= c;
	//if(last_err!=0 && s>last_err) { cpy(psf,lastm); goto lo; }
	if(last_err!=0 && s>last_err) { avg(psf,lastm); goto lo; }
	else { last_err= s; cpy(lastm,psf); }
	if(pre)printf(" %f\n",sqrt(s));
}

//---------------------------make estimate image -------------------------------
void
mk_est(rect *or, rect *ir, Mt psf[V][H]) // modify estimate
{
	int i,j,k,l,x1,x2,y1,y2,v; dbt a,e;
	int sx= or->s.x; int dx= or->e.x - sx;	// used as pos of est
	int sy= or->s.y; int dy= or->e.y - sy;
	Mt b[V][H];

	if(psfm==2) clr(m1);
#ifdef BEST
	memcpy(est0,est,sizeof(est));// to separate est before modified
#endif
	if(estm==0) { // alg0
	for(j=ir->s.y;j<ir->e.y;j++)
	for(i=ir->s.x;i<ir->e.x;i++) {
		a= err[j][i];
		for(l= iy;l<=ay;l++)	// deliver err to est
		for(k= ix;k<=ax;k++) es(j-l,i-k) += a * psf[l+U][k+M];
	}
	} else	if(estm==1) { // alg1
	for(j=ir->s.y;j<ir->e.y;j++)
	for(i=ir->s.x;i<ir->e.x;i++) {
		a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) a+= b[l+U][k+M]= best(j-l,i-k)*psf[l+U][k+M];

		//if(a< T) a= T; if(a> 1.) a= 1.;
		a= err[j][i]/a;
		//a= err[j][i]/flt[j][i];

		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) {
			e= a*b[l+U][k+M];
			es(j-l,i-k)+= e;
			if(psfm==2) m1[l+U][k+M]+= e;
		}
	}
	} else if(estm==2) { // lucy
	for(j=0;j<dy;j++)
	for(i=0;i<dx;i++) {
		a= 0; if(psfm==2) e= es(j,i);
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) {
			if(j+l>=U && j+l<dy-U && i+k>=M && i+k<dx-M) {
			a+= rat[j+l][i+k] * psf[l+U][k+M];
			if(psfm==2) m1[l+U][k+M]+= e*(rat[j+l][i+k]-1)* psf[l+U][k+M];
			} else a+= psf[l+U][k+M];
		}
		es(j,i)*= a;
	}
	}
	for(j=0;j<dy;j++)
	for(i=0;i<dx;i++) if(es(j,i)<0) es(j,i)= 0;
}

//----------------------- centroid_of_psf --------------------------------------
int
centroid(int sx, int sy, int dx, int dy, Mt m[V][H])
{
	int i,j,x,y; Mt cx=0,cy=0; Mt t[V][H];

	if(norm1(m,(double)1.)) return 1;

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { Mt d= m[j][i]; cx+= d*(i-M); cy+= d*(j-U); }

	x= cx; y= cy;

	if(x|y){
		printf("cent=(%4.2f,%4.2f)\n",cx,cy);
		cpy(t,m); memcpy(tmp,est,sizeof(est));
		if(y>=0)
		for(j=0;j<V-y;j++) {
			if(x>=0) for(i=0;i<H-x;i++) m[j][i]= t[j+y][i+x];
			else	 for(i=-x;i<H;i++)  m[j][i]= t[j+y][i+x];
		}
		else for(j=-y;j<V;j++) {
			if(x>=0) for(i=0;i<H-x;i++) m[j][i]= t[j+y][i+x];
			else	 for(i=-x;i<H;i++)  m[j][i]= t[j+y][i+x];
		}
		if(y>=0)
		for(j=0;j<dy-y;j++) {
			if(x>=0) for(i=0;i<dx-x;i++) es(j+y,i+x)= tmp[j][i];
			else	 for(i=-x;i<dx;i++)  es(j+y,i+x)= tmp[j][i];
		}
		else for(j=-y;j<dy;j++) {
			if(x>=0) for(i=0;i<dx-x;i++) es(j+y,i+x)= tmp[j][i];
			else	 for(i=-x;i<dx;i++)  es(j+y,i+x)= tmp[j][i];
		}
		//if( norm1(m,(double)1.)) return 1; 
		printf("moved %d %d\n",x,y);
	}
	return 0;
}

void
show_psf(Mt m[V][H])
{
	int k,l;
	for(l=iy;l<=ay;l++)
	for(k=ix;k<=ax;k++) {
dbt d= m[l+U][k+M]*256*50; if(d<0)d=0; if(d>255)d= 255; est[l+U][k+M]= d/255.;
	}
}

//----------------- move psf ---------(estimate psf)----------------------------
int
move_psf(rect *or, rect *of, Mt m[V][H])
{
	int i,j,k,l,c;
	int sx= or->s.x; int dx= or->e.x - sx;
	int sy= or->s.y; int dy= or->e.y - sy;
	Mt a,e=0;
	if(psfm==2){

	for(j=0;j<PY;j++)
	for(i=0;i<PX;i++) e+= best(j,i);
	mls(m,e/accl);
	add(m,m1);

	} else {

	for(l=iy;l<=ay;l++)
	for(k=ix;k<=ax;k++) {
		a= 0;
		for(j=of->s.y;j<of->e.y;j++)
		for(i=of->s.x;i<of->e.x;i++){
#ifdef RECALC
			dbt b= es(j-l,i-k);
#else
			dbt b= best(j-l,i-k);
#endif
			if(psfm==1) e= rat[j][i];
			else e= err[j][i];
			if(e>0){ for(c= 0;c<accl;c++) b*= e; a+= b; }
		}
		m1[l+U][k+M]= a;
	}
	if(psfm==3) sqr(m1);
	if(psfm==4) { sqr(m1); sqr(m1); }
	if(sum(m1)) mlt(m,m1);
	else printf("m1 is all 0\n");
	no_minus(m);

	}
	//centroid(sx,sy,dx,dy,m);
	if(norm1(m,(double)1.)) return 1;
	//show_psf(m);
	if(prm)pr_mat(m);
	return 0;
}

//--------- direction preserve filter ------------------------------
void
dfilter(int th)
{
	int i,j,k,l;
	Mt ul,uc,ur,cl,cc,cr,dl,dc,dr,hd,vd,rd,ld,min,res;
	for(j=1;j<PY-1;j++)
		for(i=1;i<PX-1;i++) {
			ul= est[j-1][i-1];
			uc= est[j-1][i];
			ur= est[j-1][i+1];
			cl= est[j  ][i-1];
			cc= est[j  ][i];
			cr= est[j  ][i+1];
			dl= est[j+1][i-1];
			dc= est[j+1][i];
			dr= est[j+1][i+1];
			hd= fabs(cl+cr-2*cc);
			vd= fabs(uc+dc-2*cc);
			rd= fabs(dl+ur-2*cc);
			ld= fabs(dr+ul-2*cc);
			min= th; res= cc;
			if(hd<min) {min= hd; res= (cl+cr+2*cc)/4; }
			if(vd<min) {min= vd; res= (uc+dc+2*cc)/4; }
			if(rd<min) {min= rd; res= (dl+ur+2*cc)/4; }
			if(ld<min) {min= ld; res= (dr+ul+2*cc)/4; }
			flt[j][i]= res;
		}
	memcpy(est,flt,sizeof(est));
}

//-----------------epsilon filter------------------------------
void
efilter(int th)
{
	int i,j,k,l,cnt;
	Mt c,d,sum;
	for(j=1;j<PY-1;j++)
		for(i=1;i<PX-1;i++) {
			c= est[j][i];
			sum= c;
			cnt= 1;
			for(l=-1;l<=1;l++)
			for(k=-1;k<=1;k++){
				d= est[j+l][i+k];
				if(fabs(d-c)<= th){ sum+= d; cnt++; }
			}
			flt[j][i]= sum/cnt;
		}
	memcpy(est,flt,sizeof(est));
}

void
init_pic(int val, Mt p[PY][PX]){
	int i,j;
	for(j=0;j<PY;j++)
	for(i=0;i<PX;i++) p[j][i]= val;
}

void
write_out_psf_jpg(int lp, char *n, Mt m[V][H])
{
	write_out(sizeof(Sif),"o.yuv");
	//sprintf(n,"%d.psf",lp); write_psf(n, m);
	sprintf(n,"convert -size %dx%d o.yuv out%d.jpg",SX,SY,lp); system(n);
}

/*
**	iterational inverse filter (IIR2)
*/
int
iir2(int o,int i,int j,rect *or,rect *ir,rect *of,Mt m[V][H])
{	
	int lp;
	if(norm1(m,(double)1.)) return 1;
#ifndef GE
	sif2dbl(or,EX,&in.y,inp);
	memcpy(est,inp,sizeof(inp));
	//init_pic(gamma_((dbt)40.),est);
#endif
	last_err= 1.0;
	for(lp= 0;lp<iloop;lp++){
		if(pri) printf("lp= %d\t",lp);
		if(estm==3)mk_unif(or,of,m);
		else { mk_err(or,of,m); mk_est(or,of,m); }
#ifdef RECALC
		mk_err(or,of,m);
#endif
		if(move_psf(or,of,m)) break;
		//efilter(1);
		dbl2sif(or,ir,EX,est,ot.y);
		sprintf(name,"o=%d (y=%d,x=%d,it=%4d)", o, j, i, lp);
		wt(&ot,name); // display on X-window
		//if(lp%100==0)write_out_psf_jpg(lp, name, m);
	}
	//efilter(1); dbl2sif(or,ir,EX,est,ot.y);
	//write_out_psf_jpg(lp, name, m);
	return 0;
}
//---
void
norm(Mt m[V][H], double c) // normalize sum of mat to be 1.
{
	int i,j; double sum= 0;
	for(j=0;j<V;j++) for(i=0;i<H;i++) sum+= m[j][i];
	sum/= c; //printf("normalize by:%f\n",sum);
	for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]/= sum;
}

/*
**	inv_mat(): inverse matrix
**	input: set square (n x n) matrix left half, and unit matrix right half.
**	output: unit made on left side, inverse matrix is made right side.
**	note: use double as matrix element type, index i,j of aji bji are 0 to n-1.
*/
void
inv_mat(int n, int m)	// inverse matrix (n x n), use m x n matrix (m= 2n)
{
	int i,j,k; double a;
	for(k=   0; k<n; k++)
	for(j= k+1; j<n; j++) { a= matrix[j][k]/matrix[k][k]; for(i=k;i<m;i++) matrix[j][i]-= matrix[k][i]*a; }
	for(j=   0; j<n; j++) { a= 1./matrix[j][j]; for(i=j;i<m;i++) matrix[j][i]*= a; }
	for(k= n-1;k>=0; k--)
	for(j= k-1;j>=0; j--) { a= matrix[j][k]; for(i=k;i<m;i++) matrix[j][i]-= matrix[k][i]*a; }
}


/*
**	put_mat: put mat[V][H] to matrix[N][N] (N= P*P (P= H)),
**	matrix[j][i]= mat[y][x] when (-M <=y[i]-y[j]< M && -M<=x[i]-x[j]< M)
**	and make unit-matrix on the right half of the matrix (i: column, j: raw)
*/
void
put_mat(Mt m[V][H])
{
	int i,j;
	for(j=0;j<N;j++)
	for(i=0;i<N;i++) {
		int dy= (i/P)-(j/P);
		int dx= (i%P)-(j%P);
		if(dy<U && dy>=-U && dx<M && dx>=-M) matrix[j][i]= m[dy+U][dx+M];
		matrix[j][i+N]= (i==j);
	}
}

#define Center (M*H+M)
#define skip_center(i) (i+(i>=Center))
void
put_mat_sk(Mt m[V][H])
{
	int i,j;
	for(j=0;j<N-1;j++) {
		int j1= skip_center(j);
	for(i=0;i<N-1;i++) {
		int i1= skip_center(i);
		int dy= (i1/P)-(j1/P);
		int dx= (i1%P)-(j1%P);
		if(dy<U && dy>=-U && dx<M && dx>=-M) matrix[j][i]= m[dy+U][dx+M];
		matrix[j][i+N]= (i==j);
	}}
}

#define CN ((P+1)*P/2)
#define CM (M*P+M)
void
get_mat(Mt m[V][H],int x, int y)	//	get center pel raw
{
	int i,j;
	int off= y*P+x;
	for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]= matrix[CN+off][CN+off+j*P+i-CM+N];
}

void
fft(complex *x,int n,int f)	// 2's power FFT
{
	int	mm,m,j,i;
	complex t,wp,w;
	for (j= i= 0; i< n; i++) { // bit reversal replacement
		if (j>i) { t= x[j]; x[j]= x[i]; x[i]= t; }	// exchange x[i],x[j]
		m= n>>1;
		while (m>=2 && j>=m) { j-= m; m>>= 1; }		// revsl-increment j
		j+= m;
	}
	wp.re= -1; wp.im=  0;	// initial wp= exp(-j pai)
	for (mm=1; mm< n; mm<<=1) {
		w.re= 1; w.im= 0;
		for (m=0; m<mm; m++) {
			j= m+mm;
			for (i= m; i< n; i+= mm*2, j+= mm*2) {
				t.re= w.re * x[j].re - w.im * x[j].im;// rotate x[j] by w
				t.im= w.re * x[j].im + w.im * x[j].re;// add and subtr
				x[j].re= x[i].re - t.re; x[j].im= x[i].im - t.im;
				x[i].re= x[i].re + t.re; x[i].im= x[i].im + t.im;
			}
			t= w;	// rotate w by wp
			w.re= t.re*wp.re - w.im*wp.im;
			w.im= t.re*wp.im + w.im*wp.re;
		}
		wp.im= sqrt(.5-wp.re*.5)*f;			// halve argment of wp
		wp.re= sqrt(.5+wp.re*.5);			// f= -1: fft, 1: ifft
	}
}

void
fft2(int nn,int f) { fft(&wk[0][0],nn*nn,f); }
/* No need to use 2-dimensional fft, we get exactly same result !
void
fft2(int nn,int f)
{
	int i,j;
	for(j=0;j<Fs;j++) fft(wk[j],nn,f);
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++) wkt[i][j]= wk[j][i];
	for(j=0;j<Fs;j++) fft(wkt[j],nn,f);
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++) wk[i][j]= wkt[j][i];
}
*/
void prep_fft(Mt m[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) wk[j][i].re= m[j][i]; }
void prep_fir(Mt m[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]= wk[j][i].re; }
void
mk_mat4()	// high pass filter
{
	int i,j;
	Mt sum= 0;
	for(j=0;j<V;j++) for(i=0;i<H;i++) sum+= mat4[j][i]= 1./((i-M)*(i-M)+(j-U)*(j-U)+2.);
	for(j=0;j<V;j++) for(i=0;i<H;i++) mat4[j][i]/= -sum;
	mat4[U][M]+= 2.0;
}
void
pr_freq(void)
{
	int i,j;
	for(j=0;j<Fs;j++){ printf("\n"); for(i=0;i<Fs;i++) printf("%5.2f ",wk[j][i].re); } printf("\n");
	for(j=0;j<Fs;j++){ printf("\n"); for(i=0;i<Fs;i++) printf("%5.2f ",wk[j][i].im); } printf("\n");
}
void
wiener(void)
{
	int i,j;
	double m,r,p;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		r= wk[j][i].re;
		m= wk[j][i].im;
		//p= r*r + m*m + 0.93;// 1.: noise
		p= r*r + m*m; if(p<1) p= 1;
		wk[j][i].re/=  p;
		wk[i][i].im/= -p;
	}
}
void
root(void)
{
	int i,j;
	double m,r;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		r= wk[j][i].re;
		m= wk[j][i].im;
		if(r<0) wk[j][i].re= -sqrt(-r);
		else	wk[j][i].re= sqrt(r);
		if(m<0) wk[i][i].im= -sqrt(-m);
		else	wk[i][i].im= sqrt(m);
	}
}


void
auto_correlation(Mt m[V][H])	// calculate auto correlation function
{
	int i,j,k,l,d;
	double c;
	for(l=0;l<V;l++)
	for(k=0;k<H;k++) {
		double s= 0;
		for(j=U;j<PY-U;j++)
		for(i=M;i<PX-M;i++) s+= in.y[j][i] * in.y[j+l-U][i+k-M];
		m[l][k]= s;
	}
	c= m[U][M];
	for(l=0;l<V;l++)
	for(k=0;k<H;k++) m[l][k]/= c;
}

void
mk_psf2(Mt m[V][H])	// make point spreading function by calc auto_corr and squared
{
	auto_correlation(m);
	mlt(m,m);
	norm1(m,(double)1);
	pr_mat(m);
}
void
mk_psf(Mt m[V][H])	// make point spreading function by calc auto_corr, and root spectrum
{
	auto_correlation(m);
	norm1(m,(double)1);
	pr_mat(m);
	prep_fft(m);
	fft2(Fs,-1);
	root();
	fft2(Fs, 1);
	prep_fir(m);
	norm1(m,(double)1);
	pr_mat(m);
}

void
peak_pos(int x0, int y0, int *px, int*py, int *pk)
{
	int x,y;
	int max= 160;
	for(y= y0;y<y0+V;y++)
	for(x= x0;x<x0+H;x++) { int d= in.y[y][x]; if(d>max) { max= d; *px= x; *py= y; *pk= max; } }
}

void
get_rect(int x0, int y0, Mt m[V][H], Sif *p)
{
	int x,y;
	for(y= y0-U;y<y0+U;y++)
	for(x= x0-M;x<x0+M;x++) m[y-y0+M][x-x0+M]= p->y[y][x];
}

double
average(Mt m[V][H])
{
	int i,j, sum= 0;

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) sum+= m[j][i];	
	return (double)sum/(V*H);
}

void
draw_line(int x, int y)
{
	int i,j;
	for(i=x-8;i<x+8;i++) in.y[y][i]= 255;
}
void
draw_line2(int x, int y)
{
	int i,j;
	for(i=y-8;i<y+8;i++) in.y[i][x]= 255;
}


int
area(Mt m[V][H])
{
	int i,j,a=0;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) a+= (m[j][i]!=0);
	//printf("%d\n",a);
	return a;
}

int
c1(int i, int j, Mt m[V][H], Mt n[V][H],Mt c, Mt last)
{
	int sum= 0;
	while (i>=0 && i<H && j>=0 && j<V && n[j][i]>=c && n[j][i]<=last+8 && m[j][i]==0){
		last= m[j][i]= n[j][i];
		sum++;
		sum+= c1(i+1,j,m,n,c,last);
		sum+= c1(i,j+1,m,n,c,last);
		sum+= c1(i-1,j,m,n,c,last);
		sum+= c1(i,j-1,m,n,c,last);
	}
	return sum;
}

int
connect1(Mt m[V][H], Mt c)
{
	Mt n[V][H];
	int i,j, r;

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) n[j][i]= m[j][i];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) m[j][i]= 0;

	r= c1(M,M,m,n,c,255);
	return r;
}

void
get_peak(int sx, int sy, Mt m1[V][H], Sif *p)
{
	int i,j,x,y,pk,min=100,t;
	Mt m[V][H];
	Mt c;

	/*
	for(j=V;j<sy-V;j+=V)
	for(i=H;i<sx-H;i+=H) {
		x= y= 0;
		peak_pos(i,j, &x, &y, &pk);
		if((x|y) //&&((p->y[y][x] + p->y[y][x+1] + p->y[y+1][x] + p->y[y+1][x+1] )/4>= 150)
				){
			get_rect(x,y,m,p);
			if((c=average(m))<pk/2) {
				printf("pk(%d %d)pk=%d c=%3.1f ",x,y,pk,c);
				//draw_line(x,y);
				connect1(m,c);
				norm(m,(double)1.);
				pr_mat(m);
				t= area(m);
				if(t<min) {
					min= t; printf("min= %d at(%d %d)\n",min,x,y);
					//draw_line2(x,y);
					cpy(m1,m);
				}
			}
		}
	}
	*/
	strcpy(name,"point");
loop:
	peak_pos_x= peak_pos_y= 0;
	while((x=peak_pos_x)==0 || (y=peak_pos_y)==0){ usleep(100000); wt(&in,name); }
	get_rect(x,y,m,p);
	c= average(m);
	printf("(%d %d) c=%3.1f\n",x,y,c);
	t= connect1(m,c);
	if(t==0) { strcpy(name,"psf is not defined."); goto loop; }
	norm(m,(double)1.);
	pr_mat(m);
	t= area(m);
	if(t<5) { strcpy(name,"too small area, re-point."); goto loop; }
	cpy(m1,m);
}

void
prep_psf(int c, Mt m[V][H],int sx, int sy)	// prepare point spreading function
{
	int i,j,k,l;

	if(c!=2)
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) {
		dbt d= mat[(j+cy)*H+(i+cx)] - O;
		if (d<0) d= 0;
		d= gamma_(d);
		m[j+U][i+M]= d;
	}
	norm1(m,(double)1);
	//mk_psf2(m);
	//get_peak(sx,sy, m, &in);
#ifdef VSEP
	for(k=0;k<4;k++) {
		for(j=0;j<V;j++)
		for(i=0;i<H;i++) mats[k][U+(j-U)*(5-k)/5][i]+= m[j][i];
		norm(mats[k],(double)1);
	}
#endif
}

/*
**	iir() : IIR inverse filtering
**	 input: p1: degraded, p2: iteration n-1, m: point spread function
**	output: p3: iteration n
*/
void
iir(int sx,int sy, Sif *p1, Sif *p2, Sif *p3, Mt m[V][H])
{
	int i,j,k,l,x1,x2,y1,y2,v;
	double center= -m[V][M]+FP+1.;

	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++){
		double a= center * p1->y[j][i] + 0.5; // center pel is from p1

		x1= -M; if(i+x1< 0) x1= -i;
		x2=  M-1; if(i+x2>sx) x2= sx-i;
		y1= -U; if(j+y1< 0) y1= -j;
		y2=  U-1; if(j+y2>sy) y2= sy-j;	// surrounding area is constranied

		for(l= y1;l<y2;l++)
		for(k= x1;k<x2;k++) if(k|l) a-= p2->y[j-l][i-k] * m[l+U][k+M];
						// from p2 and mat2[][]
		v= a; if(v<0) v= 0; else if(v>255) v= 255; // limit in [0,255]
		p3->y[j][i]= v;
	}
}

/*
**	blind deconvolution
*/
void
//iir1(int sx, int sy, dbt inp[][sx], dbt err[][sx], dbt rat[][sx], dbt est[][sx], dbt est0[][sx], int h, int v, Mt m0[][h], int lay)
iir1(int sx, int sy, dbt inp[][sx], dbt err[][sx], dbt rat[][sx], dbt est[][sx], dbt est0[][sx], int h, int v, Mt m[][h], int lay)
{
	int i,j,k,l=lay,c; dbt a,e,s;
	int ix= ixa[l],ax= axa[l],iy= iya[l],ay= aya[l];
	Mt b[v][h];
	//Mt b0[v][h];
	//Mt (*b)[h]= (Mt (*)[h])&b0[v/2][h/2]; // shift psf to center 0
	//Mt (*m)[h]= (Mt (*)[h])&m0[v/2][h/2]; // shift psf to center 0
lo:
	if(psfm==2) clr(m1);
	s= c= 0;
#define Unified
#ifdef BEST
	memcpy(est0,est,sx*sy*sizeof(dbt));	// est before modified
#endif
#ifdef Unified
	for(j=-iy;j<sy-ay;j++) // unified filter & estimate
	for(i=-ix;i<sx-ax;i++) {
		a= 0;
		for(l= iy;l<=ay;l++)
		//for(k= ix;k<=ax;k++) a+= b[l][k]=
		for(k= ix;k<=ax;k++) a+= b[l+v/2][k+h/2]=
#ifdef BEST
			//est0[j-l][i-k]*m[l][k];
			est0[j-l][i-k]*m[l+v/2][k+h/2];
#else
			//est[j-l][i-k]*m[l][k];
			est[j-l][i-k]*m[l+v/2][k+h/2];
#endif
		if(a<T) a= T; if(a>1) a= 1;
		e= err[j][i]= inp[j][i] - a;
		s+= e*e; c++;
		a= inp[j][i]/a - 1;
		for(l= iy;l<=ay;l++)
		//for(k= ix;k<=ax;k++) { e= a*b[l][k]; est[j-l][i-k]+= e; m1[l+v/2][k+h/2]+= e; }
		for(k= ix;k<=ax;k++) { e= a*b[l+v/2][k+h/2]; est[j-l][i-k]+= e; m1[l+v/2][k+h/2]+= e; }
	}
#else
	for(j=-iy;j<sy-ay;j++)
	for(i=-ix;i<sx-ax;i++){ a= 0;
		for(l= iy;l<=ay;l++)
		//for(k= ix;k<=ax;k++) a+= est[j-l][i-k] * m[l][k];
		for(k= ix;k<=ax;k++) a+= est[j-l][i-k] * m[l+v/2][k+h/2];
		if(a<T) a= T; if(a>1) a= 1;
		e= err[j][i]= inp[j][i]-a;
		rat[j][i]= inp[j][i]/a-1;
		s+= e*e; c++;
	}
#endif
	s/= c;
	if(last_err!=0 && s>last_err) { avgl((Mt*)m,(Mt*)lastm,v*h); goto lo; }
	else { last_err= s; memcpy(lastm,m,v*h*sizeof(Mt)); }
	/*
	if(last_err!=0 && s>last_err) { avgl((Mt*)m0,(Mt*)lastm,v*h); goto lo; }
	else { last_err= s; memcpy(lastm,m0,v*h*sizeof(Mt)); }
	*/
	if(pre)printf(" %f\n",sqrt(s));

#ifndef Unified
#ifdef Alg0
	for(j=-iy;j<sy-ay;j++) // alg 0 moving of estimate
	for(i=-ix;i<sx-ax;i++) //est[j][i]+= err[j][i]; //(alg-1)
	for(l= iy;l<=ay;l++)
	//for(k= ix;k<=ax;k++) est[j-l][i-k]+= m[l][k]* err[j][i];
	for(k= ix;k<=ax;k++) est[j-l][i-k]+= m[l+v/2][k+h/2]* err[j][i];
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) if(est[j][i]<0) est[j][i]= 0;
#endif
#ifdef Lucy
	for(j=-iy;j<sy-ay;j++)
	for(i=-ix;i<sx-ax;i++){ a= 1;
		for(l= iy;l<=ay;l++)
		//for(k= ix;k<=ax;k++) a+= m[l][k]*rat[j+l][i+k];
		for(k= ix;k<=ax;k++) a+= m[l+v/2][k+h/2]*rat[j+l][i+k];
		est[j][i]*= a;
	}
#endif
	for(j=-iy;j<sy-ay;j++)
	for(i=-ix;i<sx-ax;i++) { a= 0;
		for(l= iy;l<=ay;l++)
		//for(k= ix;k<=ax;k++) a+= b[l][k]= est[j-l][i-k]*m[l][k];
		for(k= ix;k<=ax;k++) a+= b[l+v/2][k+h/2]= est[j-l][i-k]*m[l+v/2][k+h/2];
		if(a<T) a= T; if(a>1) a= 1;
		a= err[j][i]/a;
		for(l= iy;l<=ay;l++)
		//for(k= ix;k<=ax;k++) { e= a*b[l][k]; est[j-l][i-k]+= e; m1[l+v/2][k+h/2]+= e; }
		for(k= ix;k<=ax;k++) { e= a*b[l+v/2][k+h/2]; est[j-l][i-k]+= e; m1[l+v/2][k+h/2]+= e; }
	}
#endif
	if(psfm==2){ e= 0;
		for(j=0;j<sy;j++)
		for(i=0;i<sx;i++) e+= est[j][i];
		//mlsl((Mt*)m0,e/accl,v*h);
		//addl((Mt*)m0,(Mt*)m1,v*h);
		mlsl((Mt*)m,e/accl,v*h);
		addl((Mt*)m,(Mt*)m1,v*h);
	} else
	for(l= iy;l<=ay;l++)
	for(k= ix;k<=ax;k++) { a= 0;
		for(j=-iy;j<sy-ay;j++)
		for(i=-ix;i<sx-ax;i++) if((e= err[j][i])>0)a+= est[j-l][i-k]*e*e;
		if(lay) a= sqrt(a);
		//a= sqrt(a); a= sqrt(a); a= sqrt(a);
		//m[l][k]*= a;
		m[l+v/2][k+h/2]*= a;
	}
	//centroid(0,0,sx,sy,m0);
	//norm_hir(h,v,m0);
	norm_hir(h,v,m);
}

void
iir11(int sx, int sy, int sz, dbt inp[][sz], dbt err[][sz], dbt rat[][sz], dbt est[][sz], int h, int v, Mt m[][h], int lay)
{
	int i,j,k,l=lay,c; dbt a,e,s,t, cnt= 0;
	int ix= ixa[l],ax= axa[l],iy= iya[l],ay= aya[l];
	Mt b[v][h];
	Mt c0[v][h];
	clrl((Mt*)c0,v*h); t= 0;
lo:
	t=c= 0;
	s= 0;
	for(j=ay;j<sy+iy;j++)
	for(i=ax;i<sx+ix;i++) {
		a= 0;
		s+= est[j][i];
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) a+= b[l+v/2][k+h/2]= est[j-l][i-k] * m[l+v/2][k+h/2];
		if(a<T) a= T; if(a>1) a= 1;
		e= err[j][i]= inp[j][i] - a;
		t+= e*e; c++;
		a= inp[j][i]/a - 1;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) { e= a*b[l+v/2][k+h/2]; est[j-l][i-k]+= e; c0[l+v/2][k+h/2]+= e; }
	}
	t/= c;
	if(last_err!=0 && t>last_err && cnt++<10) { avgl((Mt*)m,(Mt*)lastm,h*v); printf("bk\n"); goto lo; }
	else { last_err= t; cpyl((Mt*)lastm,(Mt*)m,h*v); }
	if(pre)printf("%d %f\n",lay,sqrt(t));

	if(psfm==2){ mlsl((Mt*)c0,accl/s,v*h); addl((Mt*)m,(Mt*)c0,v*h); }
	else
	for(l= iy;l<=ay;l++)
	for(k= ix;k<=ax;k++) { a= 0;
		for(j=ay;j<sy+iy;j++)
		for(i=ax;i<sx+ix;i++) if((e= err[j][i])>0)a+= est[j-l][i-k]*e*e;
		if(lay) a= sqrt(a);
		a= sqrt(a); a= sqrt(a);	// for ina3.yuv 2
		m[l+v/2][k+h/2]*= a;
	}
	norm_hir(h,v,m);
}

void
iir12(rect *or, int sz, int szy, dbt inp[][sz], dbt err[][sz], dbt rat[][sz], dbt est[][sz], int h, int v, Mt m[][h], int lay)
{
	int i,j,k,l=lay,c; dbt a,e,s,t, cnt= 0;
	int ix= ixa[l],ax= axa[l],iy= iya[l],ay= aya[l];
	int x= or->s.x;
	int y= or->s.y;
	int ex= or->e.x;
	int ey= or->e.y;
	Mt b[v][h];
	Mt c0[v][h];
	clrl((Mt*)c0,v*h); t= 0;
#ifndef FULLP
	x+= ax; ex+= ix;
	y+= ay; ey+= iy;
#endif
lo:
	s=t=c= 0;
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) {
		a= 0;
		s+= est[j][i];
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) { a+= b[l+v/2][k+h/2]= est[LY(j-l,szy)][LX(i-k,sz)] * m[l+v/2][k+h/2]; }
		if(a<T) a= T; if(a>1) a= 1;
		e= err[j][i]= inp[j][i] - a;
		t+= e*e; c++;
		a= inp[j][i]/a - 1;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) { e= a*b[l+v/2][k+h/2]; est[LY(j-l,szy)][LX(i-k,sz)]+= e; c0[l+v/2][k+h/2]+= e; }
	}
	t/= c;
	if(last_err!=0 && t>last_err && cnt++<10) { avgl((Mt*)m,(Mt*)lastm,h*v); printf("bk\n"); goto lo; }
	else { last_err= t; cpyl((Mt*)lastm,(Mt*)m,h*v); }
	if(pre)printf("%d %f\n",lay,sqrt(t));

	if(psfm==2){ mlsl((Mt*)c0,accl/s,v*h); addl((Mt*)m,(Mt*)c0,v*h); }
	else
	for(l= iy;l<=ay;l++)
	for(k= ix;k<=ax;k++) { a= 0;
		for(j=y;j<ey;j++)
		for(i=x;i<ex;i++) if((e= err[j][i])>0)a+= est[LY(j-l,szy)][LX(i-k,sz)]*e*e;
		if(lay) a= sqrt(a);
		a= sqrt(a); a= sqrt(a);	// for ina3.yuv 2
		m[l+v/2][k+h/2]*= a;
	}
	norm_hir(h,v,m);
}

void
expands(int l, int dv, int dvl,
	int h,  int v,
	int hu, int vu,
	Mt ml[DY][DX][V][H],
	Mt mu[DY][DX][V][H])
{
	int n,m;
	Mt s[V][H];
	Mt t[V][H];
	Mt u[V][H];
	Mt w[V][H];
	for(n=0;n<dv;n++)
	for(m=0;m<dv;m++) {
		expand_psf(h,v,hu,vu,ml[n*2][m*2],mu[n][m]);
		cpy(ml[n*2  ][m*2+1],ml[n*2][m*2]);
		cpy(ml[n*2+1][m*2  ],ml[n*2][m*2]);
		cpy(ml[n*2+1][m*2+1],ml[n*2][m*2]);
	}
	/*
	for(n=0;n<dv;n++)
	for(m=0;m<dv;m++) {
		expand_psf(h,v,hu,vu,ml[n*2][m*2],mu[n][m]);

		if(m+1<dv){
			cpy(t,mu[n][m]);
			add(t,mu[n][m+1]);
			expand_psf(h,v,hu,vu,ml[n*2][m*2+1],t);
		} else cpy(ml[n*2  ][m*2+1],ml[n*2][m*2]);

		if(n+1<dv){
			cpy(s,mu[n][m]);
			add(s,mu[n+1][m]);
			expand_psf(h,v,hu,vu,ml[n*2+1][m*2],s);
		} else cpy(ml[n*2+1][m*2  ],ml[n*2][m*2]);

		if(m+1<dv && n+1<dv){
			add(t,mu[n+1][m]);
			add(t,mu[n+1][m+1]);
			expand_psf(h,v,hu,vu,ml[n*2+1][m*2+1],t);
		} else cpy(ml[n*2+1][m*2+1],ml[n*2][m*2]);
	}
	*/
	/*
	for(n=0;n<dv;n++)
	for(m=0;m<dv;m++) { int i,j;
		expand_psf(h,v,hu,vu,s,mu[n][m]);		// s: up-lleft
		if(m+1<dv) expand_psf(h,v,hu,vu,u,mu[n][m+1]);	// u: right
		else cpy(u,s);
		if(n+1<dv) expand_psf(h,v,hu,vu,t,mu[n+1][m]);	// t: down
		else cpy(t,s);
		sub(u,s); mls(u,1./(dvl*2-1));
		sub(t,s); mls(t,1./(dvl*2-1));
		for(j=0;j<dvl;j++) {
			cpy(w,s);
			for(i=0;i<dvl;i++) { cpy(ml[n*2+j][m*2+i],w); add(w,u); }
			add(s,t);
		}
	}
	*/
}

/*
**	fir() : FIR filter
**	 input: p1, psf: m[][]
**	output: p2
*/
void
fir(int sx,int sy, Sif *p1, Sif *p2,Mt m[V][H])
{
	int i,j,k,l,x1,x2,y1,y2,v;

	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++){
		double a= 0.5;

		x1= -M; if(i+x1< 0) x1= -i;
		x2=  M-1; if(i+x2>sx) x2= sx-i;
		y1= -U; if(j+y1< 0) y1= -j;
		y2=  U-1; if(j+y2>sy) y2= sy-j;

		for(l= y1;l<y2;l++)
		for(k= x1;k<x2;k++) a+= p1->y[j-l][i-k]* m[l+U][k+M];
		//v= sqrt(a);
		v= a;
		if(v<0) v= 0; else if(v>255) v= 255;
		p2->y[j][i]= v;
	}
}

read_in_yuv_file(int z, char *n)
{
	FILE *f= fopen(n, "rb"); if(!f) { fprintf(stderr,"%s ropen err\n", n); exit(1); }
	if(fread(&in,1,z,f)<z) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);
}

write_out(int z,char *n)
{
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wopen err\n",n); exit(1); }
	if(fwrite(&ot,1,z,f)<z) { fprintf(stderr,"%s write err\n",n); exit(1); }
	fclose(f);
}

read_psf(char *n, Mt m[V][H])
{
	FILE *f= fopen(n, "rb"); if(!f) { fprintf(stderr,"%s ropen err\n",n); exit(1); }
	if(fread(m,1,sizeof(Mt)*V*H,f)<sizeof(Mt)*V*H) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);
}

Mt c[V*2][H*2];

read_exp_psf(char *n, Mt m[V][H])
{
	int i,j,x,y;
	Mt a[V/2][H/2];
	Mt b[V][H];
	Mt cx,cy,sm,d;
	FILE *f= fopen(n, "rb"); if(!f) { fprintf(stderr,"%s ropen err\n",n); exit(1); }
	if(fread(a,1,sizeof(Mt)*V*H/4,f)<sizeof(Mt)*V*H/4) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);

	for(j=0;j<V/2;j++)
	for(i=0;i<H/2;i++) b[j*2  ][i*2  ]= b[j*2  ][i*2+1]= b[j*2+1][i*2  ]= b[j*2+1][i*2+1]= a[j][i];

	cx=0; cy=0;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { d= b[j][i]; cx+= d*(i-M); cy+= d*(j-U); sm+= d; }
	x= cx/sm;
	y= cy/sm;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) c[j-y+V][i-x+H]= b[j][i];

	for(j=0;j<V-1;j++)
	for(i=0;i<H-1;i++) m[j][i]= (c[j+V][i+H] + c[j+V][i+H+1] + c[j+V+1][i+H] + c[j+V+1][i+H+1])/4;
}

write_psf(char *n, Mt m[V][H])
{
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wopen err\n",n); exit(1); }
	if(fwrite(m,1,sizeof(Mt)*V*H,f)<sizeof(Mt)*V*H) { fprintf(stderr,"%s write err\n",n); exit(1); }
	fclose(f);
}

void
pr_trace(void)
{
int i;
for(i=0;i<N;i++){ if(i%H==0) printf("\n"); printf("%7.4f ",matrix[i][i+N]); } printf("\n");
}

void
rnd_pel(int sx,int sy, Sif *p)
{
	int i,j;
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++)p->y[j][i]= rand()&255;
}

void
mult_mat( Mt a[N], Mt b[N])
{
	int i,j;
	for(j=0;j<N;j++) {
		double s= 0;
		for(i=0;i<N;i++) s+= matrix[j][i+N]*a[i];
		b[j]= s;
	}
}
void
mult_mat_sk( Mt a[N], Mt b[N])
{
	int i,j;
	for(j=0;j<N-1;j++) {
		double s= 0;
		for(i=0;i<N-1;i++) s+= matrix[j][i+N]*a[skip_center(i)];
		//for(i=0;i<N-1;i++) { int k= skip_center(i); s+= matrix[j][k+N]*a[k]; }
		b[skip_center(j)]= s;
	}
	b[Center]= 0;
}
void minus_mat(Mt a[N]) { int i; for(i=0;i<N;i++)a[i]= -a[i]; }


void prep_mat(Mt m[V][H]) {
	m[0][0]= 0;
	m[0][M-1]= 0;
	m[0][H-1]= 0;

	m[U-1][0]= 0;
	m[U-1][M-1]= 0;
	m[U-1][H-1]= 0;

	m[V-1][0]= 0;
	m[V-1][M-1]= 0;
	m[V-1][H-1]= 0;
	/*
	int i,j;
	double sum=0;
	Mt s[V][H];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) s[j][i]=0;

	for(j=1;j<V;j++)
	for(i=1;i<H;i++) s[j][i]= m[j-1][i-1];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { int r2= (i-M)*(i-M)+ (j-U)*(j-U); sum+= s[j][i]*= exp(-r2/32.); }

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) m[j][i]= s[j][i]/sum;
	*/
}

gaussian(Mt s[V][H]) { int i,j;
	for(j=0;j<V;j++) for(i=0;i<H;i++) { int r2= (i-M)*(i-M)+(j-U)*(j-U); s[j][i]= 
		//(1-r2/64.)*
			exp(-r2/64.); }
	norm(s,(double)1);
}


Mt b[V][H];

rev(Mt a[V][H]) {
	int i,j;
	for(j=0;j<V;j++) for(i=0;i<H;i++) b[j][i]= a[V-1-j][H-1-i];
	for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= b[j][i];
}

#ifdef INV_MAT
void
get_mat_fir(int sx, int sy, int x, int y)
{
	get_mat(mat3, x, y);
	norm(mat3,(double)1);
	//pr_mat(mat3);
	fir(sx,sy,&in,&ot,mat3);
}
#endif

rect rect1;

void
mk_rect()
{
	int x,y;
	peak_pos_x= 0;
	peak_pos_y= 0;
	while(peak_pos_x==0 && peak_pos_y==0) { wt(&ot,"set upper left corner"); usleep(100000); }
	rect1.s.x= peak_pos_x;
	rect1.s.y= peak_pos_y;

	peak_pos_x= 0;
	peak_pos_y= 0;
	while(peak_pos_x==0 && peak_pos_y==0) { wt(&ot,"set lower right corner"); usleep(100000); }
	rect1.e.x= peak_pos_x;
	rect1.e.y= peak_pos_y;

	/*
	hline(rect1.s.y, rect1.s.x, rect1.e.x);
	hline(rect1.e.y, rect1.s.x, rect1.e.x);
	vline(rect1.s.x, rect1.s.y, rect1.e.y);
	vline(rect1.e.x, rect1.s.y, rect1.e.y);
	grid= 1;
	*/
}

void
sub_rect(rect *a, rect *b) {
	a->s.x-= b->s.x;
	a->s.y-= b->s.y;
	a->e.x-= b->s.x;
	a->e.y-= b->s.y;
}

void
init_psfa(void) {
	int i,j,k,l;
	for(l=0;l<DY;l++)
	for(k=0;k<DX;k++)
	for(j=0;j< V;j++)
	for(i=0;i< H;i++) psfa[l][k][j][i]= (1./(V*H));
}

void
avg_est(int sx, int sy)
{
	int i,j;
	dbt a= 0;
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) a+= est[j][i];
	a/= sx*sy;
#ifdef FULLP
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) est[j][i]= a;
#else
	for(j=ay;j<sy+iy;j++)
	for(i=ax;i<sx+ix;i++) est[j][i]= a;
#endif
}
#ifdef HIR
void
avg_est_l(int sx, int sy, int l)
{
	int i,j;
	int ix= ixa[l],ax= axa[l],iy= iya[l],ay= aya[l];
	dbt a= 0;
	sx>>=l; sy>>=l;
#ifdef FULLP
	ix= iy= ax= ay= 0; 
#endif
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) switch(l) {
		case 0: a+= est [j][i]; break;
		case 1: a+= est2[j][i]; break;
		case 2: a+= est3[j][i]; break;
		case 3: a+= est4[j][i]; break;
		case 4: a+= est5[j][i]; break;
	}
	a/= sx*sy;
	for(j=ay;j<sy+iy;j++)
	for(i=ax;i<sx+ix;i++) switch(l) {
		case 0: est [j][i]= a; break;
		case 1: est2[j][i]= a; break;
		case 2: est3[j][i]= a; break;
		case 3: est4[j][i]= a; break;
		case 4: est5[j][i]= a; break;
	}
}
#endif
void
sub_add_img(Sif *p,Sif *q,Sif *r,int sx, int sy)
{
	int i,j;
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) {
		int d= p->y[j][i] + q->y[j][i] - r->y[j][i];
		if(d<0)d=0; if(d>255)d=255;
		p->y[j][i]= d;
	}
}

Mt m22[V2][H2];
Mt m23[V3][H3];
Mt m24[V4][H4];
Mt m25[V5][H5];
void
expand_disp(int l, rect *or, rect *ir)
{
	if(expd){
		if(l==4)expand_direct(4,tmp,est5);
		else if(l==3)expand_direct(3,tmp,est4);
		else if(l==2)expand_direct(2,tmp,est3);
		else if(l==1)expand_direct(1,tmp,est2);
		else if(l==0)expand_direct(0,tmp,est);
		dbl2sif(or,ir,EX,tmp,ot.y);
	} else {
		if(l>=4) expand_img(EX/8,EY/8,est4,est5);
		if(l>=3) expand_img(EX/4,EY/4,est3,est4);
		if(l>=2) expand_img(EX/2,EY/2,est2,est3);
		if(l>=1) expand_img(EX,EY,est, est2);
		dbl2sif(or,ir,EX,est,ot.y);
	}
}

Mt m3[HIR][DY][DX][V][H];

//-- deconvolution function --
void
deconv(int sx, int sy, int ex, int ey, int sz, Mt m2[V][H])
{
	int k,x,y;
	rect ir,or,of;// of= ir - or;

#ifdef TST
	norm(m2,(double)1);
	pr_mat(m2);
	memcpy(&ot,&in,sz);
	getchar();
	for(k=0;k<iloop;k++){
		fir(ex,ey,&ot,&ou,m2);	// filter ot ==> ou
		sub_add_img(&ot,&in,&ou,ex,ey);	// ot+= (in - ou)
		sprintf(name,"%d",k); wt(&ot,name);
		getchar();
	}
	/*
	//rev(m2);
	norm(m2,(double)-1);
	m2[U][M]+= 2;
	pr_mat(m2);
	for(k=0;k<iloop;k++){
		printf("%d",k);
		sprintf(name,"%d",k);
		fir(ex,ey,&in,&ot,m2);
		wt(&ot,name);
		memcpy(&in,&ot,sz);
		getchar();
	}
	*/
	//norm(m2,(double)-1); m2[U][M]+= 2; pr_mat(m2); fir(sx,sy,&in,&ot,m2);
	//gaussian(mat3); sub(m2,mat3); m2[U][M]+= 1; pr_mat(m2); fir(sx,sy,&in,&ot,m2);
#endif
#ifdef LPC
	//auto_correlation(m2);
	norm(m2,(double)1);
	pr_mat(m2);
	put_mat_sk(m2); inv_mat(N-1,N*2-1);	// skip-center setting to N-1 x (2N-1) matrix 
	mult_mat_sk((Mt*)m2,(Mt*)mat3);	// inversed matrix x m2 ==> mat3 (with skipping center)
	prep_mat(mat3);				// to remove 8 point big values
	norm(mat3,(double)-1);
	pr_mat(mat3);
	mat3[U][M]+= 2; pr_mat(mat3); fir(ex,ey,&in,&ot,mat3);
	wt(&ot,"in.yuv");
	getchar();
#endif
#ifdef INV_MAT
	x= y= -1;
	put_mat(m2); inv_mat(N,N*2);
	do{
		if(x!=xoff||y!=yoff) {
			x= xoff;
			y= yoff;
			sprintf(name,"x= %d, y= %d",x,y);
			get_mat_fir(ex,ey,x,y);
		}
		wt(&ot,name);
	}while(1);
#endif
#ifdef Wiener
	getchar();
	prep_fft(m2); fft2(Fs,-1); wiener(); fft2(Fs,1); prep_fir(mat3);
	norm(mat3,(double)1);
	pr_mat(mat3); fir(ex,ey,&in,&ot,mat3); wt(&ot,name);
	getchar();
	memcpy(&in,&ot,sz);
	mk_mat4(); fir(ex,ey,&in,&ot,mat4); wt(&ot,name);
	getchar();
#endif
#ifdef IIR
	getchar();
	norm(m2,(double)FP);
	for(k=0;k<iloop;k++){
		memcpy(&ou,&ot,sz);
		iir(ex, ey, &in, &ou, &ot, m2);
		sprintf(name,"%d\n",k); wt(&ot,name);
		getchar();
	}
#endif
#ifdef IIR1
	{
	int l,c, v[5]={V,V2,V3,V4,V5}, h[5]={H,H2,H3,H4,H5};
	Mt *mp[5]= {(Mt*)m2, (Mt*)m22, (Mt*)m23, (Mt*)m24, (Mt*)m25};
	Mt *ip[5]= {(Mt*)inp,(Mt*)inp2,(Mt*)inp3,(Mt*)inp4,(Mt*)inp5};
	Mt *sp[5]= {(Mt*)est,(Mt*)est2,(Mt*)est3,(Mt*)est4,(Mt*)est5};
	Mt *sp0[5]= {(Mt*)est0,(Mt*)est20,(Mt*)est30,(Mt*)est40,(Mt*)est50};
	Mt *ep[5]= {(Mt*)err,(Mt*)err2,(Mt*)err3,(Mt*)err4, (Mt*)err5};
	Mt *rp[5]= {(Mt*)rat,(Mt*)rat2,(Mt*)rat3,(Mt*)rat4, (Mt*)rat5};

	if(gpsf){ while(peak_pos_x==0){ wt(&in,"get_psf"); usleep(100000); } avge= 1; }
	norm(m2,(double)1);
	or.s.x= or.s.y= 0;
	or.e.x= ex; or.e.y= ey;
	ir= or;
	sif2dbl(&ir,EX,in.y,inp);
	sif2dbl(&ir,EX,in.y,est);

	for(l=1;l<HIR;l++) {
		shrink_img(ex>>l,ey>>l,ip[l],ip[l-1]);
		shrink_img(ex>>l,ey>>l,sp[l],sp[l-1]);
		if(gpsf)shrink_psf(h[l],v[l],h[l-1],v[l-1],mp[l],mp[l-1]);
	}
	if(!gpsf)flat_psf(mp[l-1],v[l-1]*h[l-1]);
	while(--l>=0) {
		int lp= (l)?HLP:iloop;
		if(avge)avg_est_l(ex,ey,l);
		last_err= 0;
		or.e.x= ex>>l;
		or.e.y= ey>>l;
		for(k=0;k<lp;k++) {
			//iir1(ex>>l,ey>>l,ip[l],ep[l],rp[l],sp[l],sp0[l],h[l],v[l],mp[l],l);
			//iir11(ex>>l,ey>>l,ex>>l,ip[l],ep[l],rp[l],sp[l],h[l],v[l],mp[l],l);
			iir12(&or,ex>>l,ey>>l,ip[l],ep[l],rp[l],sp[l],h[l],v[l],mp[l],l);
			expand_disp(l,&or,&ir); sprintf(name,"Layer= %d: Iter= %d",l,k+1); wt(&ot,name);
		}
		if(l)expand_psf(h[l-1],v[l-1],h[l],v[l],mp[l-1],mp[l]);
	}

	// for chroma
	l= 1;
	ir.e.x= ex>>l; ir.e.y= ey>>l;
	or= ir;
	for(c=0;c<2;c++){
		sif2dbl(&ir,ex>>l,in.c[c],inp2);
		memcpy(est2,inp2,sizeof(inp2));
		if(avge)avg_est_l(ex,ey,l);
		shrink_psf(h[l],v[l],h[l-1],v[l-1],mp[l],mp[l-1]);
		last_err= 0;
		for(k=0;k<20;k++) {
			iir12(&or,ex>>l,ey>>l,ip[l],ep[l],rp[l],sp[l],h[l],v[l],mp[l],l);
			dbl2sif(&or,&ir,ex>>l,est2,ot.c[c]); sprintf(name,"Chroma %d",k+1); wt(&ot,name);
		}
	}

	}
#endif

#ifdef IIR2
	init_psfa();
#ifdef GE
	sif2g_est(&in,inp);
	sif2g_est(&in,est);
	if(avge)avg_est(ex,ey);
#endif

#ifdef FULL
	if(gpsf){ while(peak_pos_x==0){ wt(&in,"get_psf"); usleep(100000); } avge= 1; }
	or.s.x= or.s.y= 0;
	or.e.x= SX; or.e.y= SY;		// or: full image
	ir= or;
	ir.s.x+= M; ir.e.x-= M;
	ir.s.y+= U; ir.e.y-= U;		// ir: inside rect
	of= ir; sub_rect(&of,&or);	// of: ir - or
	iir2(0,0,0,&or,&ir,&of,m2);
#endif

// point rectangles
#ifdef PART
	flat_psf((Mt*)m2,V*H);
	while(1){
	mk_rect();
	ir= or= rect1;
	or.s.x-= M; or.e.x+= M;		// or: outside rect
	or.s.y-= U; or.e.y+= U;
	of= ir; sub_rect(&of,&or);	// of: ir - or
	iir2(0,0,0,&or,&ir,&of,m2);
	}
#endif

// divide image
#ifdef DIVD
	{
	Mt m[V][H]; int i,j,o;
	cpy(m,m2); cpy(psfa[0][0],m);


	for(o=0;o<OLOP;o++) {
	for(j=0;j<DY;j++) {
	for(i=0;i<DX;i++) {
		or.s.x= i*SX/DX; if(i==DX-1) or.e.x= ex; else or.e.x= or.s.x+SX/DX;
		or.s.y= j*SY/DY; if(j==DY-1) or.e.y= ey; else or.e.y= or.s.y+SY/DY;
		ir= or;
#ifdef GE
		if(i==0) ir.s.x+= M; if(i==DX-1) ir.e.x-= M;	// ir: inside of or
		if(j==0) ir.s.y+= U; if(j==DY-1) ir.e.y-= U;	// on the edges of full
#else
		// or: outside of ir, when over edge, it is retrieved, and ir is shrinked
		or.s.x-= M; if(or.s.x< 0) { or.s.x= 0; ir.s.x= M; }
		or.s.y-= U; if(or.s.y< 0) { or.s.y= 0; ir.s.y= U; }
		or.e.x+= M; if(or.e.x>ex) { or.e.x= ex; ir.e.x= ex-M; }
		or.e.y+= U; if(or.e.y>ey) { or.e.y= ey; ir.e.y= ey-U; }
#endif
		if(gpsf){ while(peak_pos_x==0){ wt(&in,"get_psf"); usleep(100000); } peak_pos_x= 0; cpy(m,m2); avge= 1; }
		else {
			//cpy(m,m2);
			if(j&&i==0) cpy(m,m2);
			if(j) avg(m,psfa[j-1][i]);
			if(o){
				if(i<DX-1) avg(m,psfa[j][i+1]);
				if(j<DY-1) avg(m,psfa[j+1][i]);
				avg(m,psfa[ j][ i]);
			}
		}
		of= ir; sub_rect(&of,&or);	// of: ir - or
		if(iir2(o,i,j,&or,&ir,&of,m)) break ;
		//centroid(0,0,0,0,m);
		cpy(psfa[j][i],m);
	}}
	//write_out_psf_jpg(o, name, m);
	}
	}	
#endif
#endif
#ifdef IIR3
	{
	int l, v[5]={V,V2,V3,V4,V5}, h[5]={H,H2,H3,H4,H5};
	Mt *ip[5]= {(Mt*)inp,(Mt*)inp2,(Mt*)inp3,(Mt*)inp4,(Mt*)inp5};
	Mt *sp[5]= {(Mt*)est,(Mt*)est2,(Mt*)est3,(Mt*)est4,(Mt*)est5};
	Mt *ep[5]= {(Mt*)err,(Mt*)err2,(Mt*)err3,(Mt*)err4,(Mt*)err5};
	Mt *rp[5]= {(Mt*)rat,(Mt*)rat2,(Mt*)rat3,(Mt*)rat4,(Mt*)rat5};
	int xw= ex>>(HIR-1);
	int yw= ey>>(HIR-1);
	int dv= 1;

	if(gpsf){ while(peak_pos_x==0){ wt(&in,"get_psf"); usleep(100000); } avge= 1; }

	norm(m2,(double)1);
	or.s.x= or.s.y= 0;
	or.e.x= ex; or.e.y= ey;
	ir= or;
	sif2dbl(&ir,EX,&in.y,inp);
	sif2dbl(&ir,EX,&in.y,est);

	for(l=1;l<HIR;l++) {
		shrink_img(ex>>l,ey>>l,ip[l],ip[l-1]);
		shrink_img(ex>>l,ey>>l,sp[l],sp[l-1]);
		if(gpsf)shrink_psf(h[l],v[l],h[l-1],v[l-1],m3[l],m3[l-1]);
	}
	if(!gpsf) flat_psf(m3[l-1][0][0],v[l-1]*h[l-1]);

	while(--l>=0) {		// hierarchical deconvolution from upper to lower
		int lp= (l)?HLP:iloop;
		int m,n,d;
		if(avge)avg_est_l(ex,ey,l);

		// whole image first
#ifdef FULLP
		for(k=0;k<lp;k++)
		for(or.s.y= n= 0; n<dv; n++, or.s.y+= yw) 
		for(or.s.x= m= 0; m<dv; m++, or.s.x+= xw) {
			if(prm) printf("(%d, %d)\n", n,m);
			last_err= 0;
			or.e.x= or.s.x + xw;
			or.e.y= or.s.y + yw;
			iir12(&or,ex>>l,ey>>l,ip[l],ep[l],rp[l],sp[l],h[l],v[l],m3[l][n][m],l);
			expand_disp(l,&or,&ir); sprintf(name,"Layer= %d: (%d, %d) Iter= %d",l,n,m,k+1); wt(&ot,name);
		}
#else
		for(k=0;k<lp;k++)
		for(n=0;n<dv;n++){ int y=  (n)?n*yw-v[l]/2:0;
			int yd= (dv==1)?yw:(n==0||n==dv-1)?yw+v[l]/2:yw+v[l];
		for(m=0;m<dv;m++){ int x=  (m)?m*xw-h[l]/2:0;
			int xd= (dv==1)?xw:(m==0||m==dv-1)?xw+h[l]/2:xw+h[l];
			if(prm) printf("(%d, %d)\n", n,m);
			d= y*(ex>>l) + x;
			last_err= 0;
			iir11(xd,yd,ex>>l,ip[l]+d,ep[l]+d,rp[l]+d,sp[l]+d,h[l],v[l],m3[l][n][m],l);
			expand_disp(l,&or,&ir); sprintf(name,"Layer= %d: (%d, %d) Iter= %d",l,n,m,k+1); wt(&ot,name);
		}}
#endif
		if(l) expands(l, dv, 2, h[l-1], v[l-1], h[l], v[l], m3[l-1], m3[l]);
		dv*= 2;
	}
	}
#endif
}

void
cut_out(char *n,int sx,int sy, int d,int e)
{
	int i,j,c,ex= sx+d,ey= sy+e;
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wo err\n",n); exit(1); }
	for(j=sy;j<ey;j++)
	 if(fwrite(&ot.y[j][sx],1,d,f)<d) { fprintf(stderr,"%s wr err\n",n); exit(1); }
	sx/=2; sy/=2; ey/=2; d/=2;
	for(c=0;c<2;c++) for(j=sy;j<ey;j++)
	 if(fwrite(&ot.c[c][j][sx],1,d,f)<d) { fprintf(stderr,"%s wr err\n",n); exit(1); }
	fclose(f);
}


void
init_flat(Uc *mat)
{
	int i,j;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++)mat[(j+U)*H+i+M]= 1;
}

void
get_psf(int x, int y)
{
	int i,j;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) mat2[j][i]= gamma_((dbt)in.y[y+j-U][x+i-M]);
	norm1(mat2,(double)1.);
	printf("get_psf: at (%d,%d).\n",x,y);
}

void
readin_psf(char *n)
{
	int i,j,d,x=0,y=0;
	FILE *f= fopen(n,"r");
	if(!f) { fprintf(stderr,"cant read %s\n",n); exit(1); }
	fscanf(f,"%d %d", &x, &y);
	if(x!=H||y!=V) { fprintf(stderr,"psf mismatch\n",n); exit(1); }
	printf("%d x %d\n",x,y);

	for(j=0;j<y;j++) {
	for(i=0;i<x;i++) {
		fscanf(f,"%d",&d);
		printf("%d ",d);
		mat2[j][i]= d+0.25;
	}
	printf("\n");
	}
	printf("readin PSF: %s OK\n",n);
}

//-- usage and main --
void
usage(char *c) {
	fprintf(stderr,
	"usage: %s [size_x size_y] file.yuv\n (size_x <= %d, size_y <= %d) \n",
	c,SX,SY); exit(1);
}


int
main(int c, char **v)
{
	int sx=SX,sy=SY,sz= sizeof(Sif);
	char *cm= *v;

	init_flat(mat);

	c--; v++;
	while(c){
		     if(strncmp(*v,"-e",2)==0) estm= atoi(*v+2);
		else if(strncmp(*v,"-p",2)==0) psfm= atoi(*v+2);
		else if(strncmp(*v,"-a",2)==0) accl= atoi(*v+2);
		else if(strncmp(*v,"-l",2)==0) iloop= atoi(*v+2);
		else if(strncmp(*v,"-i",2)==0) avge= atoi(*v+2);
		else if(**v=='-'){
			fprintf(stderr,"unknown option:%d\n",*v);
			usage(cm);
		}
		else break;
		c--; v++;
	}

	if(c==3) {
		sx= atoi(*v++); if(sx>SX) usage(cm);
		sy= atoi(*v++); if(sy>SY) usage(cm);
	} else if(c==2) read_exp_psf(*v++,mat2);
			//read_psf(*v++,mat2);
			//readin_psf(*v++);
	else if(c!=1) usage(cm);

	read_in_yuv_file(sz,*v);

	iwt(name,&in,sx,sy);
	wt(&in,name); prep_psf(c,mat2,sx,sy);

	memcpy(&ot,&in,sz);
	memcpy(&ou,&in,sz);
	/*
	cut_out("in1.yuv",0,200,512,512);
	cut_out("in2.yuv",0,600,512,512);
	cut_out("in3.yuv",800,600,512,512);
	cut_out("in4.yuv",1600-512,1200-512,512,512);
	cut_out("in5.yuv",160,120,1024,560);
	cut_out("in6.yuv",400,300,400,400);
	cut_out("inc.yuv",0,200,400,400);
	cut_out("in0.yuv",128,12,256,256);
	cut_out("in0.yuv",152,216,256,256);
	cut_out("ina.yuv",200,400,512,512);
	cut_out("ina2.yuv",100,300,512,512);
	cut_out("ina3.yuv",500,200,512,512);
	cut_out("inb1.yuv",200,400,512,512);
	*/
#ifdef CUT_OUT
	cut_out("ind1.yuv",100,300,512,512); exit(1);
#endif
	sprintf(name,"convert -size %dx%d %s out0.jpg",sx,sy,*v); system(name);
	deconv(0,0,sx,sy,sz,mat2);

	write_out(sz,"o.yuv");
	sprintf(name,"convert -size %dx%d o.yuv out.jpg",sx,sy); system(name);
	system("rm o.yuv");

	//while(1) { wt(&ot,"complete"); usleep(100000); }
	return 0;
}
